import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;


public class MapFormula {

    /**here is the formula for the interface*/

    public static double crossFunction(double x) {
	double y=(1-x-Math.pow((2+x)*(5-2*x)*(1-4*x),1.0/3))/Math.sqrt(3);
	return(y);
    }

    /**maps the interval [0,1] to the interval [ROOT,1/4].
       Here ROOT is the crossing point on the x-axis, about .239.*/

    public static double domain(double t) {
	double a=crossPoint();
	double b=.2499999999999999;
	double c=t*t*a+(1-t*t)*b;
	return(c);
    }

    /**Here is a double approximation to the crossing point.
       It is the positive root of the polynomial 1-4x-x^2+x^3*/
    public static double crossPoint() {
	return(0.2391232782565544);
    }

    /**This gives the barrier, based on the functions above.*/

    public static Complex[] barrier0() {
	Complex[] Z=new Complex[500];
	for(int i=0;i<500;++i) {
	    double t=1.0*i/500;
	    double x=domain(t);
	    double y=crossFunction(x);
	    Z[i]=new Complex(x,y);
	}
	return(Z);
    }

    /**reflected image*/

    public static Complex[] barrier1() {
	Complex[] Z=barrier0();
	for(int i=0;i<Z.length;++i) {
	    Z[i].y=-Z[i].y;
	}
	return(Z);
    }

    /**images under the triangle symmetry group, S3*/

    public static Complex[] barrier(int k) {
	Complex[] Z={};
	if(k%2==0) Z=barrier0();
	if(k%2==1) Z=barrier1();
	int m=(k-k%2)/2;
	Complex w=Octahedron.cr(m);
	for(int i=0;i<Z.length;++i) Z[i]=Complex.times(Z[i],w);
	return(Z);
    }





}

