import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;
import java.awt.image.*;
import java.io.File;

public class PictureCanvas extends ScaleCanvas implements MouseListener,MouseMotionListener,KeyListener {
    Manager M;
    AffineTransform A;
    Complex SOURCE;
    Complex RIVAL;
    Complex ANTI;
    Color COLOR;
    ListenSquare CONTROL;
    Point JX;
    boolean PRESS;   
    Voronoi VM;
    int SELECT;
    ListenSquare TITLE;
    Color PALETTE[]=new Color[5];

     public PictureCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 addKeyListener(this);
	 SELECT=0;
	 TITLE=new ListenSquare(500,0,100,80);
	 setScales(300,300,87);
	 SOURCE=new Complex(0,0);
	 RIVAL=Octahedron.specialPoint();
	 ANTI=Octahedron.anti(RIVAL);
	 CONTROL=new ListenSquare(0,0,599,80);
	 PRESS=false;    
	 Point JX=new Point(0,0);
     }


   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g); 
      drawCenter(g);    
      if(M.C.DISPLAY.L[5].on==1)  drawBarycentric(g);
      if(M.C.DISPLAY.L[3].on==1)  DrawVoronoiImages.main(this,g);
      if(M.C.DISPLAY.L[4].on==1)  DrawVoronoi.main(this,g);
      if(M.C.DISPLAY.L[2].on==1)  DrawCutLocus.main(this,g);
      if(M.C.DISPLAY.L[6].on==1)  drawBarrier(g);
      drawTriangulation(g);
      if(M.C.DISPLAY.L[1].on==1)  drawSpider(g);
      if(M.C.DISPLAY.L[0].on==1)  DrawGeometricMap.main(this,g);
      drawSource(g);  
      if(M.C.DISPLAY.L[7].on==1)  drawMap(g);
   }


    public void drawBG(Graphics2D g) {
	g.setColor(ColorCanvas.C[0][0]);
	g.fillRect(0,0,this.getWidth(),this.getHeight());
    }

    public boolean voronoiFilter(int q) {
	int q0=getTriangleChoice();
	if(M.C.DISPLAY.L[3].on==0) return true;
	if(q==q0) return true;
	return false;
    }


    public int getTriangleChoice() {
	int q=M.C.DEV.val;
	q=(6-q)%6;
	return q;
    }

    public void drawSource(Graphics2D g) {
	drawPoint(g,SOURCE,Color.black,3);
    }

    public void drawMap(Graphics2D g) {
	Color C=ColorCanvas.C[0][4];
      	drawPoint(g,SOURCE,C,3);
	drawPoint(g,ANTI,C,3);
	Complex[] W={SOURCE,ANTI};
	GraphicsHelp.draw(g,this,W,C,2);
    }

    public void drawPoint(Graphics2D g,Complex z,Color C,int k) {
	g.setColor(C);
	Path2D.Double gp=GraphicsHelp.makeDot(z);
	g.setStroke(new BasicStroke(k));
	gp=transform(gp);
	g.draw(gp);
	g.fill(gp);
	g.setStroke(new BasicStroke(1));
    }

    public void drawTriangulation(Graphics2D g) {
	Path2D.Double gp=new Path2D.Double();
	for(int j=0;j<3;++j) {
	for(int i=-5;i<5;++i) {
	    gp.reset();
	    Complex z1=new Complex(1+i*1.5,-20);
	    Complex z2=new Complex(1+i*1.5,+20);
	    z1=Complex.times(z1,Octahedron.cr(j));
	    z2=Complex.times(z2,Octahedron.cr(j));
	    Complex[] Z={z1,z2};
	    GraphicsHelp.draw(g,this,Z,ColorCanvas.C[0][1],1);
	}}
    }

    public void drawCenter(Graphics2D g) {
	Path2D.Double gp=Triangulation.tri(0,new Complex(0,0));
	gp=transform(gp);
	g.setColor(ColorCanvas.C[0][0]);
	g.fill(gp);
    }

    public void drawBarycentric(Graphics2D g) {
	Color COL=ColorCanvas.C[0][2];
      	int a=M.C.DISPLAY.L[0].on;
	int b=M.C.DISPLAY.L[1].on;
	Complex[][] W=Triangulation.specialSegments();
	for(int i=0;i<9;++i) {
            GraphicsHelp.draw(g,this,W[i],COL,1);
	}
    }

    public void drawBarrier(Graphics2D g) {
	Color COL=ColorCanvas.C[0][3];
	for(int k=0;k<6;++k) {
	  Complex[] Z=MapFormula.barrier(k);
	  GraphicsHelp.draw(g,this,Z,COL,1);
	}

    }

    public void drawSpider(Graphics2D g) {
	Complex s=new Complex(SOURCE);
	Complex r=new Complex(RIVAL);
	double BIG=Octahedron.symmDist(s,r);
	Path2D.Double gp=new Path2D.Double();

	/**big circle*/
	gp=GraphicsHelp.circle(s,BIG);
	gp=transform(gp);
	g.setColor(ColorCanvas.C[2][0]);
	g.fill(gp);
	g.setColor(ColorCanvas.C[2][1]);
	g.draw(gp);

	/**legs*/
	Complex[] w=Octahedron.symmetrize(r);
	for(int i=0;i<6;++i) {
	    Color COL=ColorCanvas.C[2][3];
	    Complex[] W={s,w[i]};
	    int wid=1;
	    double d=Complex.dist(s,w[i]);
	    double tol=.0000001;
	    if(M.C.AN.HALT==false) tol=.005;
	    if(d<BIG+tol){wid=3;COL=ColorCanvas.C[2][2];}
	    GraphicsHelp.draw(g,this,W,COL,wid);
	    GraphicsHelp.fill(g,this,W[1],ColorCanvas.C[2][4],5);
	}

    }




    public int[] getRegion() {
	int count=0;
	int[] q0=new int[6];
	double BIG=Octahedron.symmDist(SOURCE,RIVAL);
	Complex[] w=Octahedron.symmetrize(RIVAL);
	for(int i=0;i<6;++i) {
	  Complex[] W={SOURCE,w[i]};
          double d=Complex.dist(W[0],W[1]);
	  double tol=.0000001;
	  if(M.C.AN.HALT==false) tol=.001;
	  if(d<BIG+tol) {
	    q0[count]=i;
	    ++count;
	  }
	}
	int[] q1=new int[count];
	for(int i=0;i<count;++i) q1[i]=q0[i];
	return q1;
    }


    public Complex fix(Complex z) {
        Complex w=Octahedron.anti(z);
	w=Complex.conjugate(w);
	w=Complex.times(w,Octahedron.cr(2));
	return(w);
    }




    public void setSource(Point X) {
        Complex temp=unTransform(X);
	setSource(temp);
    }

    public void setSource(Complex temp) {
	int b=Triangulation.classify(temp);
	if(b==-1) return;
	SOURCE=new Complex(temp);
	RIVAL=Octahedron.findRival(SOURCE);
	ANTI=Octahedron.anti(RIVAL);
	for(int i=0;i<12;++i) {
	    Complex[] Z=Triangulation.scaffold1(i,SOURCE);
	    for(int j=0;j<3;++j) Z[j]=fix(Z[j]);
	    double test=Complex.dist(ANTI,Z[2]);
	    if(test<.000001) SELECT=i;
	}
    }

  public void mouseEntered(MouseEvent e) {
      requestFocus();
   }

   public void mouseClicked(MouseEvent e) { 
       MouseData J=MouseData.process(e);
       doMouseClick(J.X,J.mode);
   }

   public void mouseMoved(MouseEvent e) {
       MouseData J=MouseData.process(e);
       JX=J.X; 
       if(PRESS==true) 	doMouseDrag(JX,2);
   }


    public void doMouseClick(Point X,int mode) {
	if(mode==1) scaleUp(X,-1);
	if(mode==3) scaleUp(X,1);
	if(mode==2) {
	    setSource(X);
	}
	repaint();
    }

    public void doMouseDrag(Point X,int mode) {
	if(mode==2) {
	    setSource(X);
	}
	repaint();
    }

    public void mouseDragged(MouseEvent e) {
        MouseData J=MouseData.process(e);
	doMouseDrag(J.X,J.mode);
	Complex temp=unTransform(J.X);
    }

    public void mousePressed(MouseEvent e) {

    }

     public void mouseReleased(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   


    public void keyTyped(KeyEvent e) {
	char ch=e.getKeyChar();
	int test=0;
	if(ch=='q') test=1;
	if(ch=='w') test=2;
	if(ch=='e') test=3;
	if(ch=='i') test=1;
	if(ch=='o') test=2;
	if(ch=='p') test=3;
	if(test>0) doMouseClick(JX,test);
	repaint();
    }
 
    public void keyPressed(KeyEvent e) {
	int test=0;
	char ch=e.getKeyChar();
	if(ch=='w') PRESS=true;
	if(ch=='o') PRESS=true;
    }
    public void keyReleased(KeyEvent e) {
	PRESS=false;
    }

}

